

#include <time.h>

#define MAX_RANG (520)              //maximalna udaljenost mjerenja
#define ADC_SOLUTION (1023.0)       //ADC preciznost

String returnValue = "";            // varijabla u kojoj vraćamo podatke

int breakPin = 6;                   // koristimo ovaj pin za detektiranje kocnice
int breakState = 0;                 // varijabla za citanje stanja

const int PolA= 2;                  // ventilator
const int PolB = 3;                 // također ventilator
 

int pm = A0;                        // koristimo ovaj pin za citanje potenciometra

int sensityPin = A2;                // koristimo ovaj pin za detektiranje ubrzanja
bool pstate = false;                // prethodno stanje
bool state = false;                 // trenutno stanje
float dist_t, sensity_t;            // pomocne varijable za mjerenje udaljenosti
double ubrzanje = 0;                // pomocna varijabla za ubrzanje
double startTime, stopTime, vrijeme;// pomocne varijable za mjerenje vremena

int resetButton = 10;               // koristimo ovaj pin za detektiranje tipkala
int resetState = 0;                 // varijabla za citanje stanja tipkala

void setup() {
  
  pinMode(PolA, OUTPUT);            // ventilatorA
  pinMode(PolB, OUTPUT);            // ventilatorB
  pinMode(breakPin, INPUT);         // inicijaliziramo kocnicu kao ulazni izvod
  pinMode(pm, INPUT);               // postavi izvod Potenciometar (A0) kao ulazni
  pinMode(resetButton, INPUT_PULLUP); //postavi izvod resetButton (10) kao ulazni, pull-up
  sensity_t = analogRead(sensityPin);// citamo analogni izvod za udaljenost
  dist_t = sensity_t * MAX_RANG  / ADC_SOLUTION;// izracunavamo udaljenost
  pstate = dist_t < 13;             // postavljamo inicijalno stanje 
  startTime = millis();             // postavljamo pocetno vrijeme
  
  Serial.begin(115200);               // inicijaliziramo serijsku komunikaciju
  
}
void loop(){
  returnValue = "";                 // resetiramo povratnu varijablu

  // kocnica 
  breakState = digitalRead(breakPin);    // citamo podatke za kocnicu
  if (breakState == HIGH) {              // kocnica je stisnuta
    returnValue = "1";     
  } else {                          // kocnica otpustena
    returnValue = "0";  
  }

  // upravljanje
  int potenciometar = analogRead(pm);    // definiranje varijable potenciometar
  returnValue += ";";     
  returnValue += potenciometar;     // dodajemo povratnoj vrijednosti ocitanje potenciometra     

  // ubrzanje
  sensity_t = analogRead(sensityPin);// citamo analogni izvod za udaljenost
  dist_t = sensity_t * MAX_RANG  / ADC_SOLUTION;// izracunavamo udaljenost
  state = dist_t < 13;              // postavljamo trenutno stanje 
  stopTime = millis();              // postavljamo zavrsno vrijeme
  vrijeme = (stopTime - startTime)/1000;// izracunavamo vrijeme okretanja u sec
  if (state != pstate){             // ako se promijenilao stanje 
    if (state == 1 &&  vrijeme > 0.1){// ako je ociztano da ima noga
      ubrzanje = 1 / vrijeme;       // postavljano ubrzanje
    }
    startTime = millis();           // resetiramo pocetno vrijeme
    pstate = state;                 // postavljamo proslo stanje na trenutno
  }
  else{
    if (vrijeme > 1){               // ako je prosla 1 sec postavljamo ubrzanje na 0
      ubrzanje = 0;
    }
  }
  returnValue += ";";     
  returnValue += ubrzanje;          // dodajemo povratnoj vrijednosti ocitanje ubrzanja  

  // reset
  resetState = digitalRead(resetButton); //očitaj stanje izvoda i pohrani u resetState
  returnValue += ";";     
  returnValue += resetState;          // dodajemo povratnoj vrijednosti ocitanje tipkala  
  
  Serial.println(returnValue);      // saljemo podatke
  
  analogWrite(PolA, ubrzanje * 255); //palimo ventilator u odnosu na brzinu
  digitalWrite(PolB,LOW);  
  delay(100);
    
  delay(50);
}
